/* This file is part of David Deaven's personal library.
 * Copyright (c) 1996 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: gread.c,v 1.8 1996/05/29 21:11:16 deaven Exp $
 * $Author: deaven $
 */

#include <string.h>
#include "String.h"

DString::DString(char* s) : 
    _size(strlen(s) + 1),
    _string(new char[_size])
{
    strcpy(_string, s);
}

DString::DString(DString& other) :
    _size(other._size),
    _string(new char[_size])
{
    strcpy(_string, other._string);
}

DString::~DString()
{
    delete[] _string;
}

int DString::length()
{
    return strlen(_string);
}

DString& DString::append(DString& s)
{
    unsigned int need = length() + s.length() + 1;

    if (need > _size) resize(need);

    strcat(_string, s.string());

    return *this;
}

void DString::resize(unsigned int newsize)
{
    if (newsize > _size)
    {
	char *s = new char[_size];
	strcpy(s, _string);

	delete[] _string;
	_string = s;
    }
}
