/* This file is part of David Deaven's personal library.
 * Copyright (c) 1996 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: gread.c,v 1.8 1996/05/29 21:11:16 deaven Exp $
 * $Author: deaven $
 */

#ifndef _DMD_String_h_
#define _DMD_String_h_

#include <stdio.h>
#include "dmd/Object.h"

/* General manipulations of a string.
 */
class DString : public DObject {
public:
    DString(char* s = NULL);
    DString(DString& other);
    virtual ~DString();

    //--- Object overrides
    virtual char *toString();

    // The current value of the string
    char* string() { return _string; }

    // The length of the string, not including the terminating '\0'.
    int length();

    // String concatenation
    DString& append(DString&);

protected:
    // Helper to reallocate memory
    void resize(unsigned int newsize);

    unsigned int _size;
    char*	 _string;
};

#endif // _DMD_String_h_
