/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: anint.c,v 1.3 1995/12/01 17:16:34 deaven Exp $
 * $Author: deaven $
 */

#include <math.h>
#include "tools.h"

/* Some systems have this.
 */
#ifdef NO_RINT
int rint(double x)
{
	register double fp;
	register int n;
	double ip;
	fp = modf(x, &ip); n = ip;
	if(fp < -0.5)
	  --n;
	else if(fp > 0.5)
	  ++n;
	return n;
}
#endif

#ifdef NO_COPYSIGN
double copysign(double x, double y)
{
	if(x * y < 0.0) x = -x;
	return x;
}
#endif
