/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: gcopyatom.c,v 1.2 1995/08/29 22:45:15 deaven Exp $
 * $Author: deaven $
 */

#include <string.h>
#include "geometry.h"
#include "memory.h"

/* Copy the information about atom j of src to atom i
 * of dest.  Only information currently being maintained in dest
 * is copied.
 */
void Gcopyatom(Geometry *dest, int i, Geometry *src, int j)
{
      static double x[3];
      mmul3(src->box, src->x + 3*j, x);
      mmul3(dest->boxi, x, dest->x + 3*i);
      if(dest->aname[i] == NULL || strcmp(src->aname[j], dest->aname[i]) != 0)
      {
	myfree(dest->aname[i]);
	dest->aname[i] = mystrdup(src->aname[j]);
      }
      if(dest->flags != NULL)
	dest->flags[i] = (src->flags ? src->flags[j] : 0);
}

