/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: grrotate.c,v 1.3 1996/01/29 15:21:26 deaven Exp $
 * $Author: deaven $
 */

#include <stdio.h>
#include <math.h>
#include "geometry.h"
#include "tools.h"
#include "random.h"

static double xcam[3], vcam[3], up[3], axes[3*3], x0[3], mom[3];
static double t[4*4];

/* Rotate a geometry randomly around its center of number.
 * The rotation is done in physical space, not box space.
 */
Geometry *Grrotate(Geometry *g)
{
  int i;

/* scrambled rotation axes */

  Gmoment(g, NULL, mom, x0, axes);
  for(i=0; i<3; ++i) {
    xcam[i] = x0[i];
    vcam[i] = ran3();
    up[i] = ran3();
  }
  Gentra(xcam, vcam, up, t, axes); /* generate transformation */
  for(i=0; i<(g->n); ++i) {
    Transf(mmul3(g->box, g->x+i*3, xcam), t, vcam);
    (void) mmul3(g->boxi, vcam, g->x+i*3);
  }

  return g;
}
