/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: histogram2.c,v 1.2 1995/08/29 22:45:15 deaven Exp $
 * $Author: deaven $
 */

#include <stdio.h>
#include <stdlib.h>
#include "histogram.h"
#include "memory.h"
#include "tools.h"

/* Double the width of all bins in a histogram.
 */
void Histcollapse(Histogram *h)
{
	int i, m, mx, remove = 0;
	Histsort(h);
	mx = h->data[h->n - 1].m + 1; /* larger than any */

	h->dx *= 2.0;

	for(i=0; i<h->n; ++i) {
	  m = h->data[i].m;
	  if(m < 0)
	    h->data[i].m = (m - 1) / 2;
	  else
	    h->data[i].m /= 2;

	  if((i < (h->n - 1)) &&
	     (m % 2 == 0) && 
	     (m + 1 == h->data[i+1].m))
	  {
	    h->data[i+1].m = mx; /* to be deleted */
	    h->data[i].z += h->data[i+1].z;
	    ++remove;
	    ++i;
	  }
	}

	if(remove) {
	  Histsort(h);
	  h->n -= remove;
	  h->data = myrealloc(h->data, h->n * sizeof(Bindata));
	}
}
