/* This file is part of David Deaven's personal library.
 * Copyright (c) 1995 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: iov.c,v 1.1 1996/03/18 17:09:36 deaven Exp $
 */
/* Stupid implementation of io vectors
 */
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "tools.h"

int dmd_readv(int sock, struct dmd_iovec *iov, int iovcnt)
{
	int i;
	long sz, dsz, this_sz;

	sz = 0;

	for(i=0; i<iovcnt; ++i)
	{
	  this_sz = 0;
	  while(this_sz < iov[i].iov_len) {
	    dsz = read(sock, iov[i].iov_base + this_sz,
	      iov[i].iov_len - this_sz);
	    if(dsz < 0) return dsz;
	    if(dsz == 0) return sz + this_sz;
	    this_sz += dsz;
	  }
	  sz += this_sz;
	}

	return sz;
}

int dmd_writev(int sock, struct dmd_iovec *iov, int iovcnt)
{
	int i;
	long sz, dsz, this_sz;

	sz = 0;

	for(i=0; i<iovcnt; ++i)
	{
	  this_sz = 0;
	  while(this_sz < iov[i].iov_len) {
	    dsz = write(sock, iov[i].iov_base + this_sz,
	      iov[i].iov_len - this_sz);
	    if(dsz < 0) return dsz;
	    if(dsz == 0) return sz + this_sz;
	    this_sz += dsz;
	  }
	  sz += this_sz;
	}

	return sz;
}
