/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: linguafranca.h,v 1.3 1996/03/19 18:18:28 deaven Exp deaven $
 * $Author: deaven $
 */

/* How to call routines written in other languages.
 */
#ifndef _LINGUAFRANCA_H_
#define _LINGUAFRANCA_H_

#if defined(__i860) 

#define CALL_F77(name) name ## _

#elif defined(__NetBSD__)

/* This is what f2c (version of 22 July 1992  22:54:52) does
 * with names that have NO UNDERSCORE in them.  Names with
 * underscores are treated differently.
 */
#define CALL_F77(name) name ## _

#elif defined(sgi)

/* This is what SGI cc release 5.3 does.
 */
#define CALL_F77(name) name ## _

#else
/* Note: if defined(ncube) -- then name (should)=> allcaps(name), 
 * which is not implemented here.  i.e., func ==> FUNC
 * This may not be possible to do as a pre-processor directive.
 */

#define CALL_F77(name) name

#endif

#endif /* _LINGUAFRANCA_H_ */
