XCOMM $Id: machine.mk,v 1.29 1996/08/08 19:47:25 deaven Exp deaven $
XCOMM cpp macros to make standardized makefiles for different systems
XCOMM Copyright (c)1995 David Deaven

XCOMM Dave Deaven's library (libdmd) is DMDDIR (from dmdpp)
DMDDIR = __DEAVEN_LIB_HOME__

#undef __found_a_system__

#define make_stamps(dir) # <stamps>

#ifdef __NetBSD__
XCOMM #################################################################
XCOMM NetBSD open POSIX (BSD-4.4 derived)
XCOMM -----------------------------------------------------------------

#define __found_a_system__

#ifdef __i386__
ARCH_OPTIMIZE_FLAGS = -m486
#else
ARCH_OPTIMIZE_FLAGS =
#endif

CC			= gcc
C_ALWAYS_FLAGS		= -Wall -Wconversion -Wmissing-prototypes -g
C_DEBUG_FLAGS		= 
C_OPTIMIZE_FLAGS	= -O2 $(ARCH_OPTIMIZE_FLAGS)

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O2 $(ARCH_OPTIMIZE_FLAGS)

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O2 $(ARCH_OPTIMIZE_FLAGS)

JAVAC			= javac
JAVA_OPTIMIZE_FLAGS	= -O

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= -lf2c
LD_MATH_FLAGS		= -lblas -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library `lorder objs | tsort` ; ranlib library 

#define include_file(file) \
  .include "file"

#define make_depend(files,output) \
  gcc -MM $(CFLAGS) files > output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  install -c files dir

#define install_manual(name,section) \
  nroff -man name.section | gzip > $(DMDDIR)/man/catsection/name.0.gz

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/catsection/name.0.gz \
  $(DMDDIR)/man/catsection/$$l.0.gz; done

#define do_in_subdirs(_dirs,_command) \
  @ for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

XCOMM ---------------------
XCOMM This is only for my development machine --dmd
#ifdef __DEVELOPMENT__
#undef make_stamps
#define make_stamps(thisdir) \
THISDIR = thisdir@@\
include_file(/home/deaven/include/stamps.mk)

HTMLMANDIR = $(DMDDIR)/src/WWW/Software/man

#undef install_manual
#define install_manual(name,section) \
  nroff -man name.section | gzip > $(DMDDIR)/man/catsection/name.0.gz@@\
	gunzip < $(DMDDIR)/man/catsection/name.0.gz | col -b | \
	dmdman2html -title 'name manual page' > \
	$(HTMLMANDIR)/name.section.html

#undef install_manlinks
#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/catsection/name.0.gz \
  $(DMDDIR)/man/catsection/$$l.0.gz; done@@\
	for l in links; do ln -f $(HTMLMANDIR)/name.section.html \
  $(HTMLMANDIR)/$$l.section.html; done

#endif
XCOMM ---------------------

#endif

#ifdef __nCube__
XCOMM #################################################################
XCOMM nCube parallel supercomputer
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= ncc
C_ALWAYS_FLAGS		=
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O

F77			= nf77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= 
LD_MATH_FLAGS		= -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; nar qc library `nlorder objs | tsort` 

#define include_file(file) \
  include file

#define make_depend(files,output) \
  rm -f output; for f in files; do echo $$f: >> output ; \
  ncc $(CFLAGS) -H $$f >> output ; done

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __AIX__
XCOMM #################################################################
XCOMM IBM AIX systems (RS/6000 POWER and POWER2)
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		=
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O2

F77			= xlf
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O2

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= -bI:/usr/lpp/xlf/lib/lowsys.exp -lc -lxlf90 -lxlf
LD_MATH_FLAGS		= -lblas -lessl -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library `lorder objs | tsort` ; ranlib library 

#define include_file(file) \
  include file

#define make_depend(files,output) \
  for f in files; do cc $(CFLAGS) -c -E -M $$f > /dev/null; done;\
  cat *.u > output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  /usr/ucb/install -c name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __I860__
XCOMM #################################################################
XCOMM Intel i860-based Paragon parallel supercomputer
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= icc
C_ALWAYS_FLAGS		= -Knoieee
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O4

F77			= if77
F_ALWAYS_FLAGS		= -Knoieee
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O4

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= -lf
LD_MATH_FLAGS		= -lkmath

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library objs

#define include_file(file) \
  include file

#define make_depend(files,output) \
  icc -M $(CFLAGS) files > output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  rm -f $(DMDDIR)/man/mansection/name.section ;\
  cp name.section $(DMDDIR)/man/mansection

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __sgi__
XCOMM #################################################################
XCOMM Silicon Graphics (SGI) workstations
XCOMM 
XCOMM   This Makefile template has been used on IRIX 5.3/6.0 on indys
XCOMM   and PowerChallenge machines.
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		= -fullwarn
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O3 -sopt

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O2

CXX			= DCC -ansiposix
CXX_ALWAYS_FLAGS	= -fullwarn
CXX_DEBUG_FLAGS		= -g
CXX_OPTIMIZE_FLAGS	= -O3

JAVAC			= javac
JAVA_OPTIMIZE_FLAGS	= -O

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= -lftn
LD_MATH_FLAGS		= -lblas -lm

SHELL			= /usr/bin/sh

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library objs

#define include_file(file) \
  include file

#define make_depend(files,output) \
  - cc -M $(CFLAGS) files > output

#define make_cxx_depend(files,output) \
  - DCC -M $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  rm -f $(DMDDIR)/man/mansection/name.section ;\
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __ULTRIX__
XCOMM #################################################################
XCOMM Digital Equipment (DEC) Ultrix
XCOMM   Q. Why no Ultrix on the alpha?
XCOMM   A. You can't teach a new dog Ultrix.
XCOMM                                  -- Alberto Garcia
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		= 
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O2

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O2

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= -lf
LD_MATH_FLAGS		= -lblas -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library objs

#define include_file(file) \
  include file

#define make_depend(files,output) \
  cc -M $(CFLAGS) files > output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  cp files dir

#define install_manual(name,section) \
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __HP_UX__
XCOMM #################################################################
XCOMM HP/Convex Exemplar (and others, presumably)
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		= -or none
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O3

F77			= fc
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O3

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= 
LD_MATH_FLAGS		= -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library `lorder objs | tsort`

#define include_file(file) \
  include file

#define make_depend(files,output) \
  rm -f output; touch output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  rm -f $(DMDDIR)/man/mansection/name.section ;\
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __CRAY__
XCOMM #################################################################
XCOMM CRAY Research C90 and T3D
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		=
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O 1

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O 1

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= guavac
JAVA_OPTIMIZE_FLAGS	=

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= 
LD_MATH_FLAGS		= -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library `lorder objs | tsort`

#define include_file(file) \
  include file

#define make_depend(files,output) \
  rm -f output; touch output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  rm -f $(DMDDIR)/man/mansection/name.section ;\
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __Alpha__
XCOMM #################################################################
XCOMM Digital Equipment Corporation (DEC) Alpha-based OSF systems
XCOMM -----------------------------------------------------------------

#define __found_a_system__

CC			= cc
C_ALWAYS_FLAGS		= 
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= javac
JAVA_OPTIMIZE_FLAGS	= -O

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	= 
LD_MATH_FLAGS		= -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library `lorder objs | tsort`

#define include_file(file) \
  include file

#define make_depend(files,output) \
  rm -f output; touch output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  for f in files; do rm -f dir/$$f; cp $$f dir; done

#define install_manual(name,section) \
  rm -f $(DMDDIR)/man/mansection/name.section ;\
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

#ifdef __found_a_system__
#else
XCOMM #################################################################
XCOMM Generic configuration (assume ATT/SYSV)
XCOMM -----------------------------------------------------------------

CC			= cc
C_ALWAYS_FLAGS		= 
C_DEBUG_FLAGS		= -g
C_OPTIMIZE_FLAGS	= -O

F77			= f77
F_ALWAYS_FLAGS		=
F_DEBUG_FLAGS		= -g
F_OPTIMIZE_FLAGS	= -O

CXX			= g++
CXX_ALWAYS_FLAGS	= -fhandle-exceptions -Wall -Wconversion -Wmissing-prototypes -g
CXX_DEBUG_FLAGS		=
CXX_OPTIMIZE_FLAGS	= -O

JAVAC			= javac
JAVA_OPTIMIZE_FLAGS	= -O

LD_ALWAYS_FLAGS		= -L$(DMDDIR)/lib
LD_FORTRAN_FLAGS	=
LD_MATH_FLAGS		= -lblas -lm

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) $(JAVAFLAGS) $<

#define make_library(objs,library) \
  rm -f library ; ar qc library objs

#define include_file(file) \
  include file

#define make_depend(files,output) \
  cc -M $(CFLAGS) files > output

#define make_cxx_depend(files,output) \
  g++ -MM $(CXXFLAGS) files > output

#define install_files(files,dir) \
  cp files dir

#define install_manual(name,section) \
  cp name.section $(DMDDIR)/man/mansection/name.section

#define install_manlinks(name,section,links) \
  for l in links; do ln -f $(DMDDIR)/man/mansection/name.section \
  $(DMDDIR)/man/mansection/$$l.section; done

#define do_in_subdirs(_dirs,_command) \
  for dir in _dirs; do \
  (cd $$dir; echo "executing _command in $$dir"; _command; cd ..); done

#endif

XCOMM #################################################################
XCOMM Common definitions
XCOMM

#define StandardMakefileTarget \
Makefile: Makefile.mk @@\
	$(DMDDIR)/bin/dmdpp Makefile.mk > Makefile @@\
Makefiles: @@\
	for dir in $(SUBDIRS); do (cd $$dir; $(DMDDIR)/bin/dmdconfig; cd ..); done

#define MakeInSubdirs for dir in $(SUBDIRS); do (cd $$dir; make; cd ..); done

XCOMM ------ End of machine.mk ----------------------------------------
