/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: matmul3.c,v 1.3 1996/05/09 16:22:24 deaven Exp $
 * $Author: deaven $
 */

#include <stdio.h>
#include "tools.h"

/* 3x3 matrix -- matrix multiply
 */
double *matmul3(double a[3*3], double b[3*3], double c[3*3])
{
	int i, j;
	double *cc;
	static double cl[3*3];

	cc = (b == c ? cl : c);

	for(j=0; j<3; ++j)
	  for(i=0; i<3; ++i)
	    cc[i + 3*j] =
	      a[3*j    ] * b[i    ] +
	      a[3*j + 1] * b[i + 3] +
	      a[3*j + 2] * b[i + 6];

	if(b == c) for(i=0; i<9; ++i) c[i] = cl[i];

	return c;
}

