/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: norm.c,v 1.3 1996/01/29 15:21:26 deaven Exp $
 * $Author: deaven $
 */

#include <math.h>
#include "tools.h"

double Norm(double u[3])
{
	double d, s;
	d = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];
	if(d > 0.0) {
	  d = sqrt(d);
	  s = 1.0/d;
	  u[0] *= s;
	  u[1] *= s;
	  u[2] *= s;
	}
	return d;
}

