/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: rancat.c,v 1.4 1995/12/01 17:18:04 deaven Exp $
 * $Author: deaven $
 */

#include <stdio.h>
#include <stdlib.h>
#include "random.h"

char *usage = "usage: %s [-n n] [-s seed]\n";

extern int ran3_seed;

void main(int argc, char **argv)
{
  int arg, i, n = 1;

  for(arg=1; arg<argc; ++arg) {
    if(argv[arg][0] == '-') {
      switch(argv[arg][1]) {
	case 'n':
	  sscanf(argv[++arg], "%d", &n);
	  break;
	case 's':
	  sscanf(argv[++arg], "%d", &ran3_seed);
	  break;
	default:
	  fprintf(stderr, usage, argv[0]);
	  exit(1);
      }
    } else {
      fprintf(stderr, usage, argv[0]);
      exit(1);
    }
  }

  for(i=0; i<n; ++i)
  {
	printf("%g %s", (double) ran3(), (i % 8 == 7 ? "\n" : ""));
  }
  if (n % 8 != 0) printf("\n");

  exit(0);
}
