/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: rgb.h,v 1.6 1996/08/22 22:24:09 deaven Exp deaven $
 * $Author: deaven $
 */

#ifndef _RGB_H_
#define _RGB_H_

#ifdef __cplusplus
extern "C" {
#endif

#define RGB_CMAX 0xff	/* maximum integer value of color intensity */
typedef struct {
	unsigned char r;	/* RGB components in range 0 - RGB_CMAX */
	unsigned char g;
	unsigned char b;
} Color;

void ColorAddDatabase(char *file);
Color ColorFromName(char *name);
void ColorDefine(Color c, char *name);
char *ColorName(Color c);

#ifdef __cplusplus
}
#endif

#endif /* _RGB_H_ */
