/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: setenv.c,v 1.1 1996/03/19 18:42:24 deaven Exp $
 * $Author: deaven $
 */

#include <stdlib.h>
#include <unistd.h>
#include "dmd/tools.h"
#include "dmd/memory.h"

#if DMD_TOOLS_NEED_SETENV

/* For brain-dead versions of OSs trying to be UNIX, but failing,
 * this is a replacement for the standard libc function.
 * I don't know why SYSV dropped setenv, since they invented it;
 * nevertheless, they seem to now be using putenv (BSD invented).
 */
int setenv(char *var, char *value, int overwrite)
{
	int r = 0, exists = (getenv(var) == NULL ? 0 : 1);
	char buf[FILENAME_MAX];
	if(!exists || overwrite)
	{
	  /* the OS might keep this memory... so duplicate it...  sigh
	   */
	  sprintf(buf, "%s=%s", var, value);
	  r = putenv(mystrdup(buf));
	}
	return r;
}

#endif
