/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: slaterkoster.h,v 1.2 1995/08/29 22:45:15 deaven Exp deaven $
 * $Author: deaven $
 */

#ifndef _SLATERKOSTER_H_
#define _SLATERKOSTER_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NORBAT
#define NORBAT 4
#elif NORBAT != 4
#error can only do 4 orbitals per atom
#endif

void
SKget(double sp[4], double cx, double cy, double cz, double s[10]);

void 
SKgetd(double sh[4], double cx, double cy, double cz, double ds[3][10]);

void SKunpack(double a[10], double c[NORBAT][NORBAT]);

extern int SKitab[NORBAT][NORBAT];
extern int SKstab[NORBAT][NORBAT];

#ifdef __cplusplus
}
#endif

#endif /* _SLATERKOSTER_H_ */
