/* This file is part of David Deaven's personal library.
 * Copyright (c) 1994 David Deaven
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: transf.c,v 1.3 1996/01/29 15:22:10 deaven Exp $
 * $Author: deaven $
 */

#include "tools.h"

/* Apply 4x4 transformation to a 3-coordinates.
 */
void Transf(double x[3], double t[4*4], double z[3])
{
  int i, j;
  for(i=0; i<3; ++i) {
    z[i] = t[i+12];
    for(j=0; j<3; ++j) z[i] += x[j]*t[i+4*j];
  }
}

/* Apply only the rotation part of a transformation to
 * a 3-vector.
 */
void Transfvec(double x[3], double t[4*4], double z[3])
{
  int i, j;
  for(i=0; i<3; ++i) {
    z[i] = 0.0;
    for(j=0; j<3; ++j) z[i] += x[j]*t[i+4*j];
  }
}
